<!DOCTYPE html>
<html lang="en">

<head>
  <title>task 41.10 Filter Users</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <script>
    "use strict";
    $(document).ready(function () {
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      const gCOLUMN_ID = 0;
      const gCOLUMN_FIRST_NAME = 1;
      const gCOLUMN_LAST_NAME = 2;
      const gCOLUMN_COUNTRY = 3;
      const gCOLUMN_SUBJECT = 4;
      const gCOLUMN_REGISTERED_STATUS = 5;
      const gCOLUMN_CUSTOMER_TYPE = 6;
      const gCOLUMN_ACTION = 7;

      const gCOL_NAME = ["id", "firstname", "lastname", "country", "subject", "registerStatus", "customerType", "action"];

      var gUser_list = [];

      // định nghĩa table  - chưa có data
      var gUserTable = $("#user-table").DataTable({
        // Khai báo các cột của datatable
        "columns": [
          { "data": gCOL_NAME[gCOLUMN_ID] },
          { "data": gCOL_NAME[gCOLUMN_FIRST_NAME] },
          { "data": gCOL_NAME[gCOLUMN_LAST_NAME] },
          { "data": gCOL_NAME[gCOLUMN_COUNTRY] },
          { "data": gCOL_NAME[gCOLUMN_SUBJECT] },
          { "data": gCOL_NAME[gCOLUMN_REGISTERED_STATUS] },
          { "data": gCOL_NAME[gCOLUMN_CUSTOMER_TYPE] },
          { "data": gCOL_NAME[gCOLUMN_ACTION] }
        ],
        // Ghi đè nội dung của cột action, chuyển thành button chi tiết
        "columnDefs": [
          {
            "targets": gCOLUMN_ACTION,
            "defaultContent": "<button class='info-user btn btn-info'>Chi tiết</button>"
          }]
      });

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      onPageLoading();

      // gán click event handler cho button chi tiet
      $("#user-table").on("click", ".info-user", function () {
        onButtonChiTietClick(this); // this là button được ấn
      });

      $("#btn-filter").on("click", function() {
        // Tiến hành lọc dữ liệu
        onFilterData();
      });

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      // Hàm để lọc dữ liệu
      function onFilterData() {
        // Chuẩn bị dữ liệu đầu vào
        var vFilterObj = {
          firstname: "",
          lastname: ""
        }
        // Dữ liệu lọc
        // console.log(gUser_list);

        getDataFromFilter(vFilterObj);

        // console.log(vFilterObj);

        // Xử lý dữ liệu đầu vào
        var vUserListFilter = filterData(vFilterObj);
        // console.log(vUserListFilter);

        // Xử lý dữ liệu đầu ra
        loadDataToTable(vUserListFilter);
      }

      // infoFunction sẽ là function các nút cùng gọi
      function onButtonChiTietClick(paramChiTietButton) {
        //Xác định thẻ tr là cha của nút được chọn
        var vRowSelected = $(paramChiTietButton).parents('tr');
        //Lấy datatable row
        var vDatatableRow = gUserTable.row(vRowSelected);
        //Lấy data của dòng 
        var vUserData = vDatatableRow.data();
        var vId = vUserData.id;
        var vFirstname = vUserData.firstname;
        var vLastname = vUserData.lastname;
        var vCountry = vUserData.country;

        console.log(vId);
        console.log(vFirstname);
        console.log(vLastname);
        console.log(vCountry);
      }

      // hàm chạy khi trang được load
      function onPageLoading() {
        // lấy data từ server
        $.ajax({
          url: "http://203.171.20.210:8080/devcamp-register-java-api/users",
          type: "GET",
          dataType: 'json',
          success: function (responseObject) {
            //debugger;
            gUser_list = responseObject;

            loadDataToTable(responseObject);
          },
          error: function (error) {
            console.assert(error.responseText);
          }
        });
      }

      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
      // Lấy data từ input
      function getDataFromFilter(paramFilterObj) {
        paramFilterObj.firstname = $("#inp-firstname").val().trim();
        paramFilterObj.lastname = $("#inp-lastname").val().trim();
      }

      //Hàm tiến hành lọc dữ liệu
      // Input: dữ liệu firstname, lastname filter; biến global userlist
      // Ouput: danh sách user đã được lọc
      function filterData(paramFilterObj) {
        var vResult = [];

        // Tiến hành lọc
        vResult = gUser_list.filter((paramUser) => {
          return (paramFilterObj.firstname == "" || paramUser.firstname.toLowerCase().includes(paramFilterObj.firstname.toLowerCase()))
              &&
              (paramFilterObj.lastname == "" || paramUser.lastname.toLowerCase().includes(paramFilterObj.lastname.toLowerCase()))
        })

        return vResult;
      }

      // load data to table
      function loadDataToTable(paramResponseObject) {
        //Xóa toàn bộ dữ liệu đang có của bảng
        gUserTable.clear();
        //Cập nhật data cho bảng 
        gUserTable.rows.add(paramResponseObject);
        //Cập nhật lại giao diện hiển thị bảng
        gUserTable.draw();
      }
    });
  </script>
</head>

<body>
  <div class="container">
    <h2 style="text-align: center;">Danh sách đăng ký</h2>

    <div class="row jumbotron">
      <div class="col-2">
        <label class="form-label">Firstname</label>
      </div>
      <div class="col-3">
        <input type="text" class="form-control" placeholder="Nhập first name" id="inp-firstname"/>
      </div>
      <div class="col-2">
        <label class="form-label">Lastname</label>
      </div>
      <div class="col-3">
        <input type="text" class="form-control" placeholder="Nhập last name" id="inp-lastname"/>
      </div>
      <div class="col-2">
        <button class="btn btn-success" id="btn-filter">Lọc dữ liệu</button>
      </div>
    </div>

    <table class="table table-bordered table-striped table-hover" id="user-table">
      <thead>
        <tr>
          <th>Mã người dùng</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
    </table>
  </div>

</body>

</html>